META_DIR=$(ERLTOOLS_DIR)

.SUFFIXES: .ch .cc .C .c .h .o .cpp

INCLUDE_DIR= -I$(META_DIR)$(SEP)pub$(SEP)library \
		-I$(META_DIR)$(SEP)pub$(SEP)parser \
		-I$(META_DIR)$(SEP)pub$(SEP)cplusplu \
		-I$(META_DIR)$(SEP)pub$(SEP)chopb \
		-I$(META_DIR)$(SEP)pub$(SEP)metachop \
		$(STL_INC) $(INCLUDE_DIR_LOC)

LIBRARY = $(META_DIR)$(SEP)pub$(SEP)library$(SEP)meta.$(LIB_SUF)  $(LIB_SYS) \

.cc.o :
	$(C_PLUS) -c $(MACHFLAGS) $(OPTIM_FLAGS) $(MISC_C_FLAGS) $(C_WARNING) $(INCLUDE_DIR) $(OPT_FLAGS) $*.cc
.c.o :
	$(C_PLUS) -c $(MACHFLAGS) $(OPTIM_FLAGS) $(MISC_C_FLAGS) $(C_WARNING) $(INCLUDE_DIR) $(OPT_FLAGS) $*.c
.cc.obj :
	$(C_PLUS) -c $(MACHFLAGS) $(OPTIM_FLAGS) $(MISC_C_FLAGS) $(C_WARNING) $(INCLUDE_DIR) $(OPT_FLAGS) $*.cc
.c.obj :
	$(C_PLUS) -c $(MACHFLAGS) $(OPTIM_FLAGS) $(MISC_C_FLAGS) $(C_WARNING) $(INCLUDE_DIR) $(OPT_FLAGS) $*.c

.cpp.obj :
	$(C_PLUS) -c $(MACHFLAGS) $(OPTIM_FLAGS) $(MISC_C_FLAGS) $(C_WARNING) $(INCLUDE_DIR) $(OPT_FLAGS) $*.cpp

# mettre -DI386 pour interactive

clean_inc :
	-  $(RM) *.o
	-  $(RM) *.obj
	-  $(RM) *.a
	-  $(RM) *.lib
	-  $(RM) *.ll
	-  $(RM) res.*
	-  $(RM) *.exe
	-  $(RM) -r compile.dir
	-  $(RM) core
	-  $(RM) res.*
	-  $(RM) *.~*
	-  $(RM) *.pdb
	-  $(RM) *.*~
	-  $(RM) *.viv
	-  $(RM) libtmp*.*
	-  $(RM) *.tds
	-  $(RM) *.ilk
	-  $(RM) *.lib
	-  $(RM) *.lst
	-  $(RM) *.bak
	-  $(RM) *.mbt
	-  $(RM) *.mrt
	-  $(RM) *.obr
	-  $(RM) *.ide
	-  sh -c $(RM_UNIX)

clean_inc_appli : clean_inc
	-  $(RM) m_done

all_test :
	@- for i in s* ; do \
			 echo $$i ; \
			 $$i > res.$$i 2>&1 ; diff res.$$i ref.$$i ; \
		   done
prof :
	$(MAKE) all "OPTIM_FLAGS=-g -pg" -f makefile.uni
optim :
	$(MAKE) all "OPTIM_FLAGS=-O2" -f makefile.uni
norm :
	$(MAKE) all "OPTIM_FLAGS=" -f makefile.uni
optimg :
	$(MAKE) all "OPTIM_FLAGS=-O2 -g" -f makefile.uni
checker :
	$(MAKE) all "C_PLUS=checkerg++" -f makefile.uni
check :
	$(MAKE) all "OPTIM_FLAGS=-g" "LIB_SYS=-ldbmalloc" -f makefile.uni

METAOPT =
