/*************************************************************************/
/*                                                                       */
/*        smtoken.h - All token function for ptree ( small token )       */
/*                                                                       */
/*************************************************************************/
/* This file is part of metagen                                             
   
   Metagen is a syntaxic analyser generator with backtrack.
   
   It runs on dos and unix. It generates c code. */
/* Copyright(C) 1989 Eric Lavillonniere */
/*
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING. If not, write to
   the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   
   */
#ifndef SMTOKEN_LOADED
#define SMTOKEN_LOADED 1
#define RIEN 
#ifdef SUN
#define _fastcall 
#endif
#include "memges.h"
#define NODE_MASK ~(~0x3ff)
#define REF_MASK ~(~0xffffff)
#define LANG_MASK ~(~0x03f)
#define NODE_BIT 10
#define LANG_BIT 6
#define REF_BIT 24
#define LIST 0
#define TERM_TREE ( -2 & NODE_MASK )
#define GEO ( -3 & NODE_MASK )
#define REF_TREE (-4 & NODE_MASK)
#define CLASS_TREE (-5 & NODE_MASK)
#define ENTETE_SIZE 2*sizeof(int)+2*sizeof(PPTREE)
#define treearity(x) ((PPTREE)x?(CacheRead((long)(PPTREE)x+sizeof(int))>>REF_BIT)&0xff:0)
#define ranktree(x) PosTree((PPTREE)x)
#define sontree(x, y) SonTree((PPTREE)x,y)

typedef struct a_tree {
    int          tree1 ;
    int          nb_ref ;
    struct a_tree *father ;
    struct a_tree *the_annot ;
    struct a_tree *son1 ;
    struct a_tree *son2 ;
    struct a_tree *son3 ;
    struct a_tree *son4 ;
    struct a_tree *son5 ;
    struct a_tree *son6 ;
}   TREE,   *PPTREE,    *MY_TREE ;

/**************************************************************
           Functions of auxpars
   ***************************************************************/
void            _fastcall AddRef (PPTREE) ;  /* add a reference on a tree */ 
void            _fastcall FreeRef (PPTREE) ; /* del a reference on a tree and free it */ 
PPTREE          _fastcall MakeTree (int, int) ;
PPTREE          _fastcall ReplaceTree (PPTREE, int, PPTREE) ;
PPTREE          _fastcall SonTree (PPTREE, int) ;
PPTREE          _fastcall NFatherTree (PPTREE, int) ;
PPTREE          _fastcall FatherTree (PPTREE) ;
PPTREE          _fastcall AddList (PPTREE, PPTREE) ;
PPTREE          _fastcall LMakeString (const char *string, int length) ;
PPTREE          _fastcall MakeString (const char *) ;
unsigned int    TreeSize (PPTREE) ;
char            *_fastcall Value (PPTREE) ;
int             _fastcall PosTree (PPTREE) ;
void            MetaInit () ;
void            MetaEnd () ;
class PTREE ;
PPTREE          StoreRef (PPTREE) ;
#endif /* TOKEN_LOADED  */ 
