#ifndef METACHOP_PARSER
#define METACHOP_PARSER

extern char * parseLanguage;
#include "decmetac.h"
                


#ifdef __cplusplus
#include "chopb.h"
typedef int (pretty::** _FUNC_MEMB_METACHOP) ();
class metachop: public chopb,public virtual Parser {
    public :
    
    static int init ; 
    
    metachop () {
        ptTokenArray = _tokenArray;
        ptTokenFuncArray =(_FUNC_MEMB_METACHOP) _tokenFuncArray;
        ptTokenNbFuncArray = _tokenNbFuncArray;
        InitConst ();
        
    }
    
    ~metachop () {}
    
    virtual void AsLanguage () { SwitchLang("metachop");}
    
    virtual void * rootGrammar () { return (void *) this;}
    virtual int Lex() ;
    virtual PPTREE main_entry ( int error_free) ;
    virtual PPTREE primary_expression ( int error_free) ;
    virtual PPTREE prog ( int error_free) ;
    
    
    static signed char * _tokenArray [144];
    static int (metachop::*(_tokenFuncArray [144])) ();
    static int _tokenNbFuncArray [144];

    virtual int SortKeyWord (int ret);
    virtual int UpSortKeyWord (int ret); 
    virtual void InitConst ();
    
    enum constants {
        NODE_LIST =     339 ,
        NODE_TREE =     338 ,
        SPACE =     337 ,
        SEP_OMIT =  336 ,
        SEP_BEFORE =    335 ,
        SEP_AFTER =     334 ,
        AFERAFER =  333 ,
        ALINEA =    332 ,
        CHOP_DEF =  331 ,
        NIL =   330 ,
        IN_LANG =   329 ,
        NEXT =  328 ,
        DEF_IDENT =     327 ,
        BOX =   326 ,
        EXPO =  325 ,
        EXPO_AFF =  324 ,
        ETOIETOIEGAL =  323 ,
        IN =    322 ,
        PARSE =     321 ,
        NEXTL =     320 ,
        VALUE =     319 ,
        INFESUPE =  318 ,
        FOREACH =   317 ,
        INFESEPOSUPE =  316 ,
        INFESEPBSUPE =  315 ,
        INFESEPASUPE =  314 ,
        AOUVAOUV =  313 ,
        ARRO =  312 ,
        NL_BEG =    311 ,
        TAB_BEG =   310 ,
        SPACE_BEG =     309 ,
        MAKETREE_SUP =  308 ,
        MAKETREE_INF =  307 ,
        PARSE_ELEM =    306 ,
        SIMP_ETOI =     305 ,
        ETOI_ETOI =     304 ,
        BDECR =     303 ,
        BINCR =     302 ,
        ADDR =  301 ,
        NOT =   300 ,
        LNEG =  299 ,
        POS =   298 ,
        NEG =   297 ,
        STRING_LIST =   296 ,
        LABEL =     295 ,
        THROW_ANSI =    294 ,
        ELSE =  293 ,
        TUNSIGNED =     292 ,
        TSIGNED =   291 ,
        TIDENT =    290 ,
        TFLOAT =    289 ,
        TDOUBLE =   288 ,
        RSHI =  287 ,
        LSHI =  286 ,
        LT =    285 ,
        GT =    284 ,
        GEQU =  283 ,
        LEQU =  282 ,
        PROTECT_MEMB =  281 ,
        LANGUAGE =  280 ,
        EXP =   279 ,
        ADECR =     278 ,
        AINCR =     277 ,
        ARROW =     276 ,
        REF =   275 ,
        EXP_ARRAY =     274 ,
        EXP_LIST =  273 ,
        ARROW_MEMB =    272 ,
        DOT_MEMB =  271 ,
        POINETOI =  270 ,
        TIRESUPEETOI =  269 ,
        TIRESUPE =  268 ,
        SUPESUPE =  267 ,
        INFEINFE =  266 ,
        SUPEEGAL =  265 ,
        INFEEGAL =  264 ,
        NEW_DECLARATOR =    263 ,
        REM =   262 ,
        DIV =   261 ,
        MUL =   260 ,
        POURC =     259 ,
        MESSAGE_MAP =   258 ,
        MACRO =     257 ,
        TCHAR =     256 ,
        TSHORT =    255 ,
        TLONG =     254 ,
        TINT =  253 ,
        OR =    252 ,
        VBARVBAR =  251 ,
        AND =   250 ,
        ETCOETCO =  249 ,
        COMPOUND_EXT =  248 ,
        EXTERNAL =  247 ,
        INITIALIZER =   246 ,
        LOR =   245 ,
        VBAR =  244 ,
        FUNC =  243 ,
        STAT_VOID =     242 ,
        TEMPLATE_DECL =     241 ,
        CLASS_PARAM =   240 ,
        EXP_SEQ =   239 ,
        LXOR =  238 ,
        CHAP =  237 ,
        EXCEPTION_ANSI =    236 ,
        EXCEPTION =     235 ,
        NEQU =  234 ,
        EQU =   233 ,
        EXCLEGAL =  232 ,
        EGALEGAL =  231 ,
        PRAGMA =    230 ,
        INDENT_FUNCTION_TYPE =  229 ,
        COMMENT_PLUS =  228 ,
        COMMENT_END =   227 ,
        COMMENT_MIDDLE =    226 ,
        COMMENT_START =     225 ,
        MARGIN_VALUE =  224 ,
        BRACE_ALIGN_VALUE =     223 ,
        ASSIGN_ALIGN =  222 ,
        SINGLE_SWITCH_INDENT_VALUE =    221 ,
        SIMPLIFY_VALUE =    220 ,
        SIMPLIFY =  219 ,
        MODE_VALUE =    218 ,
        TAB_VALUE =     217 ,
        CONFIG =    216 ,
        NO_PRETTY =     215 ,
        ERROR =     214 ,
        UNDEF =     213 ,
        TYP_AFF_CALL =  212 ,
        MEMBER_DECLARATOR =     211 ,
        TYP_ARRAY =     210 ,
        CFER =  209 ,
        COUV =  208 ,
        FOR_DECLARATION =   207 ,
        DECLARATION =   206 ,
        CTOR_INITIALIZER =  205 ,
        CTOR_INIT =     204 ,
        IUN =   203 ,
        IUNLONG =   202 ,
        ILONG =     201 ,
        RANGE_MODIFIER =    200 ,
        COND_AFF =  199 ,
        INTE =  198 ,
        COMPOUND =  197 ,
        PARAM_TYPE =    196 ,
        SUPE =  195 ,
        INFE =  194 ,
        CLASS_DECL =    193 ,
        AFER =  192 ,
        CATCH_ANSI =    191 ,
        EXCEPT_ANSI_ALL =   190 ,
        CAST =  189 ,
        DPOI =  188 ,
        TYP_BIT =   187 ,
        PROTECT =   186 ,
        BASE_LIST =     185 ,
        XOR_AFF =   184 ,
        OR_AFF =    183 ,
        AND_AFF =   182 ,
        RSH_AFF =   181 ,
        LSH_AFF =   180 ,
        MIN_AFF =   179 ,
        PLU_AFF =   178 ,
        REM_AFF =   177 ,
        DIV_AFF =   176 ,
        MUL_AFF =   175 ,
        AFF =   174 ,
        POINPOINPOIN =  173 ,
        VAR_LIST =  172 ,
        TYP_LIST =  171 ,
        TYP_AFF =   170 ,
        ABST_DECLARATOR =   169 ,
        DECLARATOR =    168 ,
        LAND =  167 ,
        INIT_NEW =  166 ,
        VIRG =  165 ,
        QUALIFIED =     164 ,
        MINUS =     163 ,
        TYP =   162 ,
        PFER =  161 ,
        DESTRUCT =  160 ,
        TYP_REF =   159 ,
        TYP_ADDR =  158 ,
        DEFAULT =   157 ,
        CASE =  156 ,
        TYPEDEF =   155 ,
        TEMPLATE =  154 ,
        CATCH =     153 ,
        PUBLIC =    152 ,
        PROTECTED =     151 ,
        PRIVATE =   150 ,
        CHAPEGAL =  149 ,
        VBAREGAL =  148 ,
        ETCOEGAL =  147 ,
        SUPESUPEEGAL =  146 ,
        INFEINFEEGAL =  145 ,
        TIREEGAL =  144 ,
        PLUSEGAL =  143 ,
        POURCEGAL =     142 ,
        ETOIEGAL =  141 ,
        EGAL =  140 ,
        ASM =   139 ,
        VA_ARG =    138 ,
        DELETE =    137 ,
        NEW =   136 ,
        SIZEOF =    135 ,
        TIRETIRE =  134 ,
        PLUSPLUS =  133 ,
        EXCL =  132 ,
        PLUS =  131 ,
        TIRE =  130 ,
        POUV =  129 ,
        TRY =   128 ,
        THROW =     127 ,
        FORALLSONS =    126 ,
        WHILE =     125 ,
        SWITCH =    124 ,
        RETURN =    123 ,
        PVIR =  122 ,
        IF =    121 ,
        FOR =   120 ,
        AOUV =  119 ,
        DO =    118 ,
        CONTINUE =  117 ,
        BREAK =     116 ,
        OPERATOR =  115 ,
        TILD =  114 ,
        ETCO =  113 ,
        ETOI =  112 ,
        SHORT =     111 ,
        UNSIGNED =  110 ,
        SIGNED =    109 ,
        LONG =  108 ,
        DPOIDPOI =  107 ,
        VOID =  106 ,
        CHAR =  105 ,
        INT =   104 ,
        DOUBLE =    103 ,
        CLASS =     102 ,
        UNION =     101 ,
        STRUCT =    100 ,
        ENUM =  99 ,
        CONST =     98 ,
        FRIEND =    97 ,
        VIRTUAL =   96 ,
        INLINE =    95 ,
        VOLATILE =  94 ,
        REGISTER =  93 ,
        EXTERN =    92 ,
        STATIC =    91 ,
        AUTO =  90 ,
        FUNC_SPEC =     89 ,
        TRY_UPPER =     88 ,
        END_CATCH =     87 ,
        END_CATCH_ALL =     86 ,
        AND_CATCH =     85 ,
        CATCH_UPPER =   84 ,
        CATCH_ALL =     83 ,
        END_MESSAGE_MAP =   82 ,
        BEGIN_MESSAGE_MAP =     81 ,
        DECLARE_MESSAGE_MAP =   80 ,
        IMPLEMENT_SERIAL =  79 ,
        IMPLEMENT_DYNCREATE =   78 ,
        IMPLEMENT_DYNAMIC =     77 ,
        DECLARE_SERIAL =    76 ,
        DECLARE_DYNAMIC =   75 ,
        PUSH_FUNCTION =     74 ,
        PUSH_ARGUMENT =     73 ,
        UNDEF_CONTENT =     72 ,
        SMALL_PRAGMA_CONTENT =  71 ,
        PRAGMA_CONTENT =    70 ,
        PRAGMA_INDENT_FUNCTION_TYPE =   69 ,
        PRAGMA_COMMENT_PLUS =   68 ,
        PRAGMA_COMMENT_END =    67 ,
        PRAGMA_COMMENT_MIDDLE =     66 ,
        PRAGMA_COMMENT_START =  65 ,
        PRAGMA_MARGIN =     64 ,
        PRAGMA_ASSIGN_ALIGN =   63 ,
        PRAGMA_SINGLE_SWITCH_INDENT =   62 ,
        PRAGMA_SIMPLIFY =   61 ,
        PRAGMA_BRACE_ALIGN =    60 ,
        PRAGMA_MODE =   59 ,
        PRAGMA_RANGE =  58 ,
        PRAGMA_TAB =    57 ,
        PRAGMA_CONFIG =     56 ,
        PRAGMA_NOPRETTY =   55 ,
        PRAGMA_PRETTY =     54 ,
        INCLUDE_LOCAL =     53 ,
        INCLUDE_SYS =   52 ,
        END_LINE =  51 ,
        DEFINE_NAME =   50 ,
        DEFINED_NOT_CONTINUED =     49 ,
        DEFINED_CONTINUED =     48 ,
        POINT =     47 ,
        SLAS =  46 ,
        SLASEGAL =  45 ,
        CARRIAGE_RETURN =   44 ,
        UNDEF_DIR =     43 ,
        DEFINE_DIR =    42 ,
        ERROR_DIR =     41 ,
        PRAGMA_DIR =    40 ,
        LINE_DIR =  39 ,
        ENDIF_DIR =     38 ,
        ELIF_DIR =  37 ,
        ELSE_DIR =  36 ,
        IF_DIR =    35 ,
        IFNDEF_DIR =    34 ,
        IFDEF_DIR =     33 ,
        INCLUDE_DIR =   32 ,
        OCTAL =     31 ,
        UOCTAL =    30 ,
        LOCTAL =    29 ,
        ULOCTAL =   28 ,
        HEXA =  27 ,
        UHEXA =     26 ,
        LHEXA =     25 ,
        ULHEXA =    24 ,
        INTEGER =   23 ,
        FLOAT =     22 ,
        UINTEGER =  21 ,
        LINTEGER =  20 ,
        ULINTEGER =     19 ,
        CHARACT =   18 ,
        STRING =    17 ,
        IDENT =     16 ,
        GOTO_REL =  15 ,
        GOTO =  14 ,
        STR =   13 ,
        UNMARK =    12 ,
        MARK =  11 ,
        TAB_VIRT =  10 ,
        TAB =   9 ,
        NEWLINE =   8 ,
        ATTRIBUTS =     7 ,
        PLUS____TIRETIRETIRETIRETIRETIRE____ =  6 ,
        PLACE_HOLD_CONST
    } ; 
} ; 

extern metachop * parser_metachop;

#endif
#define NODE_LIST_metachop  339
#define NODE_TREE_metachop  338
#define SPACE_metachop  337
#define SEP_OMIT_metachop   336
#define SEP_BEFORE_metachop     335
#define SEP_AFTER_metachop  334
#define AFERAFER_metachop   333
#define ALINEA_metachop     332
#define CHOP_DEF_metachop   331
#define NIL_metachop    330
#define IN_LANG_metachop    329
#define NEXT_metachop   328
#define DEF_IDENT_metachop  327
#define BOX_metachop    326
#define EXPO_metachop   325
#define EXPO_AFF_metachop   324
#define ETOIETOIEGAL_metachop   323
#define IN_metachop     322
#define PARSE_metachop  321
#define NEXTL_metachop  320
#define VALUE_metachop  319
#define INFESUPE_metachop   318
#define FOREACH_metachop    317
#define INFESEPOSUPE_metachop   316
#define INFESEPBSUPE_metachop   315
#define INFESEPASUPE_metachop   314
#define AOUVAOUV_metachop   313
#define ARRO_metachop   312
#define NL_BEG_metachop     311
#define TAB_BEG_metachop    310
#define SPACE_BEG_metachop  309
#define MAKETREE_SUP_metachop   308
#define MAKETREE_INF_metachop   307
#define PARSE_ELEM_metachop     306
#define SIMP_ETOI_metachop  305
#define ETOI_ETOI_metachop  304
#define BDECR_metachop  303
#define BINCR_metachop  302
#define ADDR_metachop   301
#define NOT_metachop    300
#define LNEG_metachop   299
#define POS_metachop    298
#define NEG_metachop    297
#define STRING_LIST_metachop    296
#define LABEL_metachop  295
#define THROW_ANSI_metachop     294
#define ELSE_metachop   293
#define TUNSIGNED_metachop  292
#define TSIGNED_metachop    291
#define TIDENT_metachop     290
#define TFLOAT_metachop     289
#define TDOUBLE_metachop    288
#define RSHI_metachop   287
#define LSHI_metachop   286
#define LT_metachop     285
#define GT_metachop     284
#define GEQU_metachop   283
#define LEQU_metachop   282
#define PROTECT_MEMB_metachop   281
#define LANGUAGE_metachop   280
#define EXP_metachop    279
#define ADECR_metachop  278
#define AINCR_metachop  277
#define ARROW_metachop  276
#define REF_metachop    275
#define EXP_ARRAY_metachop  274
#define EXP_LIST_metachop   273
#define ARROW_MEMB_metachop     272
#define DOT_MEMB_metachop   271
#define POINETOI_metachop   270
#define TIRESUPEETOI_metachop   269
#define TIRESUPE_metachop   268
#define SUPESUPE_metachop   267
#define INFEINFE_metachop   266
#define SUPEEGAL_metachop   265
#define INFEEGAL_metachop   264
#define NEW_DECLARATOR_metachop     263
#define REM_metachop    262
#define DIV_metachop    261
#define MUL_metachop    260
#define POURC_metachop  259
#define MESSAGE_MAP_metachop    258
#define MACRO_metachop  257
#define TCHAR_metachop  256
#define TSHORT_metachop     255
#define TLONG_metachop  254
#define TINT_metachop   253
#define OR_metachop     252
#define VBARVBAR_metachop   251
#define AND_metachop    250
#define ETCOETCO_metachop   249
#define COMPOUND_EXT_metachop   248
#define EXTERNAL_metachop   247
#define INITIALIZER_metachop    246
#define LOR_metachop    245
#define VBAR_metachop   244
#define FUNC_metachop   243
#define STAT_VOID_metachop  242
#define TEMPLATE_DECL_metachop  241
#define CLASS_PARAM_metachop    240
#define EXP_SEQ_metachop    239
#define LXOR_metachop   238
#define CHAP_metachop   237
#define EXCEPTION_ANSI_metachop     236
#define EXCEPTION_metachop  235
#define NEQU_metachop   234
#define EQU_metachop    233
#define EXCLEGAL_metachop   232
#define EGALEGAL_metachop   231
#define PRAGMA_metachop     230
#define INDENT_FUNCTION_TYPE_metachop   229
#define COMMENT_PLUS_metachop   228
#define COMMENT_END_metachop    227
#define COMMENT_MIDDLE_metachop     226
#define COMMENT_START_metachop  225
#define MARGIN_VALUE_metachop   224
#define BRACE_ALIGN_VALUE_metachop  223
#define ASSIGN_ALIGN_metachop   222
#define SINGLE_SWITCH_INDENT_VALUE_metachop     221
#define SIMPLIFY_VALUE_metachop     220
#define SIMPLIFY_metachop   219
#define MODE_VALUE_metachop     218
#define TAB_VALUE_metachop  217
#define CONFIG_metachop     216
#define NO_PRETTY_metachop  215
#define ERROR_metachop  214
#define UNDEF_metachop  213
#define TYP_AFF_CALL_metachop   212
#define MEMBER_DECLARATOR_metachop  211
#define TYP_ARRAY_metachop  210
#define CFER_metachop   209
#define COUV_metachop   208
#define FOR_DECLARATION_metachop    207
#define DECLARATION_metachop    206
#define CTOR_INITIALIZER_metachop   205
#define CTOR_INIT_metachop  204
#define IUN_metachop    203
#define IUNLONG_metachop    202
#define ILONG_metachop  201
#define RANGE_MODIFIER_metachop     200
#define COND_AFF_metachop   199
#define INTE_metachop   198
#define COMPOUND_metachop   197
#define PARAM_TYPE_metachop     196
#define SUPE_metachop   195
#define INFE_metachop   194
#define CLASS_DECL_metachop     193
#define AFER_metachop   192
#define CATCH_ANSI_metachop     191
#define EXCEPT_ANSI_ALL_metachop    190
#define CAST_metachop   189
#define DPOI_metachop   188
#define TYP_BIT_metachop    187
#define PROTECT_metachop    186
#define BASE_LIST_metachop  185
#define XOR_AFF_metachop    184
#define OR_AFF_metachop     183
#define AND_AFF_metachop    182
#define RSH_AFF_metachop    181
#define LSH_AFF_metachop    180
#define MIN_AFF_metachop    179
#define PLU_AFF_metachop    178
#define REM_AFF_metachop    177
#define DIV_AFF_metachop    176
#define MUL_AFF_metachop    175
#define AFF_metachop    174
#define POINPOINPOIN_metachop   173
#define VAR_LIST_metachop   172
#define TYP_LIST_metachop   171
#define TYP_AFF_metachop    170
#define ABST_DECLARATOR_metachop    169
#define DECLARATOR_metachop     168
#define LAND_metachop   167
#define INIT_NEW_metachop   166
#define VIRG_metachop   165
#define QUALIFIED_metachop  164
#define MINUS_metachop  163
#define TYP_metachop    162
#define PFER_metachop   161
#define DESTRUCT_metachop   160
#define TYP_REF_metachop    159
#define TYP_ADDR_metachop   158
#define DEFAULT_metachop    157
#define CASE_metachop   156
#define TYPEDEF_metachop    155
#define TEMPLATE_metachop   154
#define CATCH_metachop  153
#define PUBLIC_metachop     152
#define PROTECTED_metachop  151
#define PRIVATE_metachop    150
#define CHAPEGAL_metachop   149
#define VBAREGAL_metachop   148
#define ETCOEGAL_metachop   147
#define SUPESUPEEGAL_metachop   146
#define INFEINFEEGAL_metachop   145
#define TIREEGAL_metachop   144
#define PLUSEGAL_metachop   143
#define POURCEGAL_metachop  142
#define ETOIEGAL_metachop   141
#define EGAL_metachop   140
#define ASM_metachop    139
#define VA_ARG_metachop     138
#define DELETE_metachop     137
#define NEW_metachop    136
#define SIZEOF_metachop     135
#define TIRETIRE_metachop   134
#define PLUSPLUS_metachop   133
#define EXCL_metachop   132
#define PLUS_metachop   131
#define TIRE_metachop   130
#define POUV_metachop   129
#define TRY_metachop    128
#define THROW_metachop  127
#define FORALLSONS_metachop     126
#define WHILE_metachop  125
#define SWITCH_metachop     124
#define RETURN_metachop     123
#define PVIR_metachop   122
#define IF_metachop     121
#define FOR_metachop    120
#define AOUV_metachop   119
#define DO_metachop     118
#define CONTINUE_metachop   117
#define BREAK_metachop  116
#define OPERATOR_metachop   115
#define TILD_metachop   114
#define ETCO_metachop   113
#define ETOI_metachop   112
#define SHORT_metachop  111
#define UNSIGNED_metachop   110
#define SIGNED_metachop     109
#define LONG_metachop   108
#define DPOIDPOI_metachop   107
#define VOID_metachop   106
#define CHAR_metachop   105
#define INT_metachop    104
#define DOUBLE_metachop     103
#define CLASS_metachop  102
#define UNION_metachop  101
#define STRUCT_metachop     100
#define ENUM_metachop   99
#define CONST_metachop  98
#define FRIEND_metachop     97
#define VIRTUAL_metachop    96
#define INLINE_metachop     95
#define VOLATILE_metachop   94
#define REGISTER_metachop   93
#define EXTERN_metachop     92
#define STATIC_metachop     91
#define AUTO_metachop   90
#define FUNC_SPEC_metachop  89
#define TRY_UPPER_metachop  88
#define END_CATCH_metachop  87
#define END_CATCH_ALL_metachop  86
#define AND_CATCH_metachop  85
#define CATCH_UPPER_metachop    84
#define CATCH_ALL_metachop  83
#define END_MESSAGE_MAP_metachop    82
#define BEGIN_MESSAGE_MAP_metachop  81
#define DECLARE_MESSAGE_MAP_metachop    80
#define IMPLEMENT_SERIAL_metachop   79
#define IMPLEMENT_DYNCREATE_metachop    78
#define IMPLEMENT_DYNAMIC_metachop  77
#define DECLARE_SERIAL_metachop     76
#define DECLARE_DYNAMIC_metachop    75
#define PUSH_FUNCTION_metachop  74
#define PUSH_ARGUMENT_metachop  73
#define UNDEF_CONTENT_metachop  72
#define SMALL_PRAGMA_CONTENT_metachop   71
#define PRAGMA_CONTENT_metachop     70
#define PRAGMA_INDENT_FUNCTION_TYPE_metachop    69
#define PRAGMA_COMMENT_PLUS_metachop    68
#define PRAGMA_COMMENT_END_metachop     67
#define PRAGMA_COMMENT_MIDDLE_metachop  66
#define PRAGMA_COMMENT_START_metachop   65
#define PRAGMA_MARGIN_metachop  64
#define PRAGMA_ASSIGN_ALIGN_metachop    63
#define PRAGMA_SINGLE_SWITCH_INDENT_metachop    62
#define PRAGMA_SIMPLIFY_metachop    61
#define PRAGMA_BRACE_ALIGN_metachop     60
#define PRAGMA_MODE_metachop    59
#define PRAGMA_RANGE_metachop   58
#define PRAGMA_TAB_metachop     57
#define PRAGMA_CONFIG_metachop  56
#define PRAGMA_NOPRETTY_metachop    55
#define PRAGMA_PRETTY_metachop  54
#define INCLUDE_LOCAL_metachop  53
#define INCLUDE_SYS_metachop    52
#define END_LINE_metachop   51
#define DEFINE_NAME_metachop    50
#define DEFINED_NOT_CONTINUED_metachop  49
#define DEFINED_CONTINUED_metachop  48
#define POINT_metachop  47
#define SLAS_metachop   46
#define SLASEGAL_metachop   45
#define CARRIAGE_RETURN_metachop    44
#define UNDEF_DIR_metachop  43
#define DEFINE_DIR_metachop     42
#define ERROR_DIR_metachop  41
#define PRAGMA_DIR_metachop     40
#define LINE_DIR_metachop   39
#define ENDIF_DIR_metachop  38
#define ELIF_DIR_metachop   37
#define ELSE_DIR_metachop   36
#define IF_DIR_metachop     35
#define IFNDEF_DIR_metachop     34
#define IFDEF_DIR_metachop  33
#define INCLUDE_DIR_metachop    32
#define OCTAL_metachop  31
#define UOCTAL_metachop     30
#define LOCTAL_metachop     29
#define ULOCTAL_metachop    28
#define HEXA_metachop   27
#define UHEXA_metachop  26
#define LHEXA_metachop  25
#define ULHEXA_metachop     24
#define INTEGER_metachop    23
#define FLOAT_metachop  22
#define UINTEGER_metachop   21
#define LINTEGER_metachop   20
#define ULINTEGER_metachop  19
#define CHARACT_metachop    18
#define STRING_metachop     17
#define IDENT_metachop  16
#define GOTO_REL_metachop   15
#define GOTO_metachop   14
#define STR_metachop    13
#define UNMARK_metachop     12
#define MARK_metachop   11
#define TAB_VIRT_metachop   10
#define TAB_metachop    9
#define NEWLINE_metachop    8
#define ATTRIBUTS_metachop  7
#define PLUS____TIRETIRETIRETIRETIRETIRE_____metachop   6
#undef _Tak
#define _Tak(func) func 
#endif
